Index: openafs/doc/txt/RELNOTES-1.4.1
diff -c /dev/null openafs/doc/txt/RELNOTES-1.4.1:1.1.2.2
*** /dev/null	Tue Jun 13 12:10:14 2006
--- openafs/doc/txt/RELNOTES-1.4.1	Fri Apr 14 15:54:06 2006
***************
*** 0 ****
--- 1,114 ----
+                   OpenAFS Release Notes - Version 1.4.1
+      _________________________________________________________________
+ All systems: Major bugfixes.
+ New systems: MacOS 10.4 (PowerPC and Intel)
+      _________________________________________________________________
+ 
+ * Bugfixes:
+ 
+ All systems:
+ 
+ - Several race conditions in the host tracking and handling in the fileserver 
+   which could cause inconsistent behavior and crashes have been fixed.
+ 
+ - A fileserver bug where a reference to a volume could be leaked and later 
+   cause a deadlock as a result of a bulk status call
+ 
+ - Reference counting of fileserver objects in unsigned 32 bit integers 
+   instead of signed 16 bit integers.
+ 
+ - Avoid type mismatches when handling time values (betweemn 32 bit and 64 bit
+   variables).
+ 
+ - Fix a memory leak during multilevel packet queue handling.
+ 
+ - Audit log output had been updated to include FIDs for newly created files.
+ 
+ HP-UX 11i:
+ 
+ - 64 bit (large file) inodes are supported.
+ 
+ - Salvager will now handle large (>4gb) partitions.
+ 
+ * New features:
+ 
+ All systems:
+ 
+ - asetkey is now included to ease Kerberos 5 integration for server 
+   administrators.
+ 
+ - A new fileserver statistics collection including callback statistics was 
+   added.
+ 
+ - man pages are now generated.
+ 
+ Microsoft Windows:
+ 
+ - Fixes error message problems experienced by fs.exe and the AFS Explorer
+   Shell Extensions related to the use of Universal Error Codes by the 
+   AFS File Server
+ 
+ - Adds full SMB/CIFS support for byte range locking.  In this implementation
+   all locks are allocated locally and the AFS lock privilege is ignored.
+   While this will not prevent two processes on different machines from 
+   simultaneously writing to the same file, it will prevent two processes
+   on the same machine from doing so.
+ 
+ - The UP server check period has been reduced to once every ten minutes to
+   match the period used by the UNIX clients.  The shorter period will 
+   assist clients maintain RX connections through NATs.
+ 
+ - Fixes the DOWN server check logic to ensure that any server that responds
+   to a check is marked UP unless it is in the process of restarting.
+ 
+ - Add logic to better handle objects that no longer exist on the file server.
+   (VNOVNODE errors.)
+ 
+ - Prevent the removal of existing drive mappings by "afscreds.exe -M"
+ 
+ - Fixes the procmgmt library so that it doesn't cause applications that 
+   unload it to crash.
+ 
+ - Improves the warnings written to the afsd_init.log file when the 
+   Windows RPC Protocol drivers are improperly configured.
+ 
+ - Fixes "fs setserverprefs -vlserver".  Multiple calls with the same
+   server parameter could result in a crash of afsd_service.exe.
+ 
+ - The SMB/CIFS layer was audited for reference miscounts and memory leaks.
+   All SMB objects are now properly counted, locked, and released when 
+   their work is done.
+ 
+ - Prevent file truncation of the user does not have the appropriate access.
+ 
+ - Token management was re-written to allow user tokens to be preserved 
+   during integrated login and freed after logoff is complete.
+ 
+ - Added a mechanism by which abandoned SMB virtual circuits can be 
+   detected and the associated resources cleaned up.
+ 
+ - Prevent the allocation of SMB file handles with a value of 0 or 0xFFFF
+   which would be considered invalid by Windows applications.
+ 
+ - Fixed the processing of cell names to ensure that they are always
+   treated as case insensitive strings.
+ 
+ - Fixed the network provider code to avoid querying the profile location
+   if integrated login is disabled.
+ 
+ - If a mount point string is empty, return Path Not Found to the application.
+ 
+ - Windows returns WSAECONNRESET when an ICMP packet is received in response
+   to a transmitted UDP packet that cannot be delivered.  Do not mark the
+   connection as bad but instead retry the request.
+ 
+ - Fix the data written to the registry as part of the BackConnectionHostnames
+   values.
+ 
+ - Fixed the rx-lwp implementation to always generate unique rx call 
+   identitiers.
+ 
+ - The default "fs minidump" type now includes data segments.
+ 
+ 
+ 
Index: openafs/doc/txt/winnotes/afs-changes-since-1.2.txt
diff -c openafs/doc/txt/winnotes/afs-changes-since-1.2.txt:1.13.2.62 openafs/doc/txt/winnotes/afs-changes-since-1.2.txt:1.13.2.67
*** openafs/doc/txt/winnotes/afs-changes-since-1.2.txt:1.13.2.62	Sun Apr  9 03:32:54 2006
--- openafs/doc/txt/winnotes/afs-changes-since-1.2.txt	Sun Jun  4 21:34:42 2006
***************
*** 1,4 ****
! Since 1.4.1 rc10: 1.4.1 rc11 released (9 April 2006)
  
   * Add code to protect against an undercount of smb_vc_t 
     references in the smb_allVCsp list.  This is a temporary
--- 1,99 ----
! Since 1.4.1d:
! 
!  * A deadlock was detected when performing "fs flushall" if the 
!    file server reports VNOVNODE.   The scp->createBufferLock is 
!    already held by the current thread and there is no mechanism 
!    to propagate the knowledge.  Therefore, an alternate mechanism 
!    for clearing the cache must be developed.  A new function 
!    cm_RecycleSCache(scp,flags) has been extracted from 
!    cm_GetNewSCache().  This function performs the task of recycling 
!    an cm_scache_t object.  When called from cm_GetNewSCache() with 
!    no flags the expectation is that there are no associated buffers 
!    that are queued to be read or written.  When called from 
!    cm_Analyze() with the CM_SCACHE_RECYCLEFLAG_DESTROY_BUFFERS
!    flag, any queued buffers will be de-queued and marked as if 
!    the operations were performed so the data can be discarded.
! 
!  * CM_ERROR codes were logged as "unknown" by cm_Analyze.
! 
!  * In response to VNOVNODE, the parent is only discarded if the current
!    cm_scache_t is not a directory.
! 
!  * In the Ioctl FlushFile and FlushVolume functions, there were no
!    checks to protect against flushing the Freelance SCache entries.
! 
!  * In FlushFile, the wrong cm_scache_t object was being released.
! 
!  * In cm_GetNewSCache, do not allow Freelance SCache entries to be
!    recycled.  Choose a new entry if cm_RecycleSCache fails.
! 
! Since 1.4.1c:  1.4.1d (2 June 2006)
! 
!  * Add a missing lock that was lost during the pullup
!    of patchs for 1.4.1c
! 
! Since 1.4.1b:  1.4.1c (31 May 2006)
!  
!  * Speed up the performance of the cache manager by not 
!    holding the smb_fid_t mutex across calls to cm_SyncOp 
!    and AFS RPCs.
! 
!  * Ensure that all smb_fid_t flag references are protected.
! 
!  * Remove a deadlock between smb_fid_t mutex and 
!    smb_rctLock introduced in 1.4.1.
! 
!  * Fix aklog AFSID lookup to use not send the realm
!    name when the realm is the local realm for the 
!    cell.  The PT Server doesn't strip the realm 
!    name when it is the local realm.
! 
!  * Treat "\\afs\*." as an alias for "\\afs\all" 
! 
!  * Dynamically adjust the priority of server threads
!    based upon the age of the CIFS request that is 
!    being processed.  The priority is bumped one level
!    for every 15 seconds of processing time.
! 
!  * smb_SendPacket cannot release a vcp since it doesn't
!    own the reference.
! 
!  * The original openafs contribution mis-used the 
!    cm_GetCallback function.  This function should only
!    be called as a side effect of a call to
!    cm_SyncOp(CM_SCACHESYNC_NEEDCALLBACK).  The way it
!    was being called results in a FetchStatus RPC being 
!    performed even when the client already has a valid
!    callback and does so in a manner that destroys the
!    synchronization of the threads that are calling 
!    cm_SyncOp.  If nothing else this results in a 
!    significant performance penalty.
! 
! Since 1.4.1a: 1.4.1b (16 May 2006)
! 
!  * More changes to cleanup of smb_vc_t objects in
!    order to prevent race conditions.
! 
!  * Reduce the amount of Power Management event logging
!    to afsd_init.log
! 
!  * If the client detects that the IP address has 
!    changed, force the use of new RX connections.  This
!    enables the file server to recognize that the client
!    has moved.
! 
! Since 1.4.1: 1.4.1a (1 May 2006)
! 
!  * Remove a race condition and deadlock associated 
!    with cleanup of smb_vc_t objects.
! 
!  * Fix the ANSI filename support.  One function that
!    required it was missing the translations.
! 
!  * Fix the pthread library so that it can be loaded
!    and unloaded safely by an application.
! 
! Since 1.4.1 rc10: 1.4.1 released (9 April 2006)
  
   * Add code to protect against an undercount of smb_vc_t 
     references in the smb_allVCsp list.  This is a temporary
